/* datinp.f -- translated by f2c (version of 22 July 1992  22:54:52).
   You must link the resulting object file with the libraries:
	-lF77 -lI77 -lm -lc   (in that order)
*/

#ifdef __cplusplus
//extern "C" {
#endif
#include "f2c.h"

/* Common Block Declarations */

Extern struct {
    double s, b, cbar, amss, aix, aiy, aiz, aixz, aixy, aiyz, aixe;
} datain_;

#define datain_1 datain_

Extern struct {
    double delx, dely, delz;
} cgshft_;

#define cgshft_1 cgshft_

Extern struct {
    logical cgset;
} lll006_;

#define lll006_1 lll006_

Extern struct {
    integer lun001, lun002, lun003, lun004, lun005, lun006;
} lll022_;

#define lll022_1 lll022_

Extern struct {
    double desmin, desmax, dasmin, dasmax, drsmin, drsmax, thrmin, thrmax,
	     alpmin, alpmax, amhmin, amhmax, fldmin, fldmax, phimin, phimax, 
	    btamin, btamax, gmamin, gmamax, aldmin;
} lll029_;

#define lll029_1 lll029_

/* Table of constant values */

static integer c__1 = 1;
static integer c__12 = 12;

/* Subroutine */ int datinp_()
{
    /* Format strings */
    static char fmt_100[] = "(6f13.0)";
    static char fmt_400[] = "(3f10.0,12a4)";

    /* Local variables */
    static char icgtlt[4*12];
    static double weight;

    /* Fortran I/O blocks */
    static cilist io___1 = { 0, 0, 0, fmt_100, 0 };
    static cilist io___3 = { 0, 0, 0, fmt_100, 0 };
    static cilist io___4 = { 0, 0, 0, fmt_400, 0 };
    static cilist io___6 = { 0, 0, 0, fmt_100, 0 };



/* .... ROUTINE TO INPUT VEHICLE GEOMETRY AND MASS PROPERTIES. */

/* .... WRITTEN MAY 4, 1981 */
/*     LEE DUKE NASA/DFRC */




/*     INCLUDE 'include.h' */
/*     cgcalc and datinp only */
/*     ccalc, cgcalc, datinp, derivc and instrm only */
/*     cgcalc and datinp only */
/*     limtin and datinp only */

/* .... READ GEOMETRY AND MASS INFORMATION. */

    io___1.ciunit = lll022_1.lun001;
    s_rsfe(&io___1);
    do_fio(&c__1, (char *)&datain_1.s, (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&datain_1.b, (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&datain_1.cbar, (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&weight, (ftnlen)sizeof(double));
    e_rsfe();

/* .... CONVERT WEIGHT TO MASS. */

    datain_1.amss = weight / 32.174;

/* .... READ INERTIA DATA. */

    io___3.ciunit = lll022_1.lun001;
    s_rsfe(&io___3);
    do_fio(&c__1, (char *)&datain_1.aix, (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&datain_1.aiy, (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&datain_1.aiz, (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&datain_1.aixz, (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&datain_1.aixy, (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&datain_1.aiyz, (ftnlen)sizeof(double));
    e_rsfe();

/* .... READ DATA DEFINING VECTOR FROM VEHICLE CENTER OF GRAVITY TO */
/*     REFERENCE POINT OF AERODYNAMIC MODEL. */

    io___4.ciunit = lll022_1.lun001;
    s_rsfe(&io___4);
    do_fio(&c__1, (char *)&cgshft_1.delx, (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&cgshft_1.dely, (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&cgshft_1.delz, (ftnlen)sizeof(double));
    do_fio(&c__12, icgtlt, 4L);
    e_rsfe();

    lll006_1.cgset = TRUE_;

/* .... DETERMINES WHERE TO CORRECT FORCE AND MOMENT COEFFICIENTS */
/*     FROM THE REFERENCE POINT OF THE BASIC AERODYNAMIC MODEL TO */
/*     THE VEHICLE CENTER OF GRAVITY. */

/*     IF CGSET IS TRUE, THE FORCE AND MOMENT COEFFICIENT */
/*         CORRECTIONS WILL BE CALCULATED IN CGCALCC */
/*     IF CGSET IS FALSE, THE FORCE AND MOMENT COEFFICIENT */
/*         CORRECTIONS WILL BE CALCULATED IN THE USER'S CCALC. */

    if (s_cmp(icgtlt, "NO C", 4L, 4L) == 0 || s_cmp(icgtlt, "CCAL", 4L, 4L) ==
	     0 || s_cmp(icgtlt, "FORC", 4L, 4L) == 0) {
	lll006_1.cgset = FALSE_;
    }
/* .... READ IN LIMITS FOR ANGLE OF ATTACK */

    io___6.ciunit = lll022_1.lun001;
    s_rsfe(&io___6);
    do_fio(&c__1, (char *)&lll029_1.alpmin, (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&lll029_1.alpmax, (ftnlen)sizeof(double));
    e_rsfe();

/* .... CONVERT TO RADIANS */

    lll029_1.alpmin /= 57.29578;
    lll029_1.alpmax /= 57.29578;

    return 0;


} /* datinp_ */

#ifdef __cplusplus
//	}
#endif
