/* engsdl.f -- translated by f2c (version of 22 July 1992  22:54:52).
   You must link the resulting object file with the libraries:
	-lF77 -lI77 -lm -lc   (in that order)
*/

#ifdef __cplusplus
//extern "C" {
#endif
#include "f2c.h"

/* Common Block Declarations */

Extern struct {
    double c03dat[8], fgia[24], b03dat[8], ancfa[36],
	    fidlax[108], fmilax[168], fmaxax[168],
	    tidla[108], tmila[168], tmaxa[168],
	    fidla[108], fmila[168], fmaxa[168];
} engtab_;

#define engtab_1 engtab_

Extern struct {
    integer idxmc1, idxmc2;
    doublereal ratomc, ratmc1;
    integer idxhb1, idxhb2;
    doublereal ratohb, rathb1;
} engidx_;

#define engidx_1 engidx_

doublereal engsdl_0_(int n__, doublereal *arg)
{
    /* Initialized data */

    static double fgiaa[6] = { 0.0,0.3,0.5,0.7,0.9,1.0 };
    static double  anca[9] = { 0.0,0.168,0.17,0.277,0.362,0.545,0.787,0.936,1.0 };

    /* System generated locals */
    doublereal ret_val;

    /* Local variables */
    static integer i;
    static doublereal ancfa1, ancfa2, ancfa3, ancfa4, ancfb1, ancfb2,
		      gaina1, gaina2, gaina3, gaina4, gainb1, gainb2;
    static integer idxfg1, idxfg2;
    static doublereal ratfg1;
    static integer indxd1, indxd2, indxd3, indxd4, indxd5, indxd6, indxd7, 
	    indxd8, idxnc1, idxnc2;
    static doublereal ratnc1;
    static integer indxe1, indxe2, indxe3, indxe4, indxe5, indxe6, indxe7, 
	    indxe8;
    static doublereal ratofg, ratonc;


/* .... ROUTINE TO COMPUTE ENGINE MODEL SCHEDULES. */

/* .... WRITTEN AUG. 3, 1978 */
/*     LEE DUKE NASA/DFRC */






    switch(n__) {
	case 1: goto L_c07sdl;
	case 2: goto L_b07sdl;
	}



L_c07sdl:

/* .... ENTRY TO COMPUTE CORE ENGINE GAIN. */

    idxfg1 = 1;
    for (i = 2; i <= 5; ++i) {
	if (*arg >= fgiaa[i - 1]) {
	    idxfg1 = i;
	}
/* L1: */
    }
    idxfg2 = idxfg1 + 1;

    ratofg = (*arg - fgiaa[idxfg1-1])/(fgiaa[idxfg2-1] - fgiaa[idxfg1-1]);
    ratfg1 = 1.0 - ratofg;

    indxd1 = idxfg1 + (engidx_1.idxhb1 - 1 + (engidx_1.idxmc1 - 1 << 1)) * 6;
    indxd2 = indxd1 + 1;
    indxd3 = indxd1 + 6;
    indxd4 = indxd2 + 6;
    indxd5 = indxd1 + 12;
    indxd6 = indxd2 + 12;
    indxd7 = indxd3 + 12;
    indxd8 = indxd4 + 12;

    gaina1 = ratofg*engtab_1.fgia[indxd2-1] + engtab_1.fgia[indxd1-1]*ratfg1;
    gaina2 = ratofg*engtab_1.fgia[indxd4-1] + engtab_1.fgia[indxd3-1]*ratfg1;
    gaina3 = ratofg*engtab_1.fgia[indxd6-1] + engtab_1.fgia[indxd5-1]*ratfg1;
    gaina4 = ratofg*engtab_1.fgia[indxd8-1] + engtab_1.fgia[indxd7-1]*ratfg1;
    gainb1  = engidx_1.ratohb*gaina2 + gaina1*engidx_1.rathb1;
    gainb2  = engidx_1.ratohb*gaina4 + gaina3*engidx_1.rathb1;
    ret_val = engidx_1.ratomc*gainb2 + gainb1*engidx_1.ratmc1;
    return ret_val;


L_b07sdl:

/* .... ENTRY TO COMPUTE AUGMENTOR MODEL NORMALIZED CHARACTERISTICS. */

    idxnc1 = 1;
    for (i = 2; i <= 8; ++i) {
	if (*arg >= anca[i - 1]) {
	    idxnc1 = i;
	}
/* L2: */
    }
    idxnc2 = idxnc1 + 1;

    ratonc = (*arg - anca[idxnc1-1])/(anca[idxnc2-1] - anca[idxnc1-1]);
    ratnc1 = 1.0 - ratonc;

    indxe1 = idxnc1 + (engidx_1.idxhb1 - 1 + (engidx_1.idxmc1 - 1 << 1)) * 9;
    indxe2 = indxe1 + 1;
    indxe3 = indxe1 + 9;
    indxe4 = indxe2 + 9;
    indxe5 = indxe1 + 18;
    indxe6 = indxe2 + 18;
    indxe7 = indxe3 + 18;
    indxe8 = indxe4 + 18;
    ancfa1 = ratonc*engtab_1.ancfa[indxe2-1] + engtab_1.ancfa[indxe1-1]*ratnc1;
    ancfa2 = ratonc*engtab_1.ancfa[indxe4-1] + engtab_1.ancfa[indxe3-1]*ratnc1;
    ancfa3 = ratonc*engtab_1.ancfa[indxe6-1] + engtab_1.ancfa[indxe5-1]*ratnc1;
    ancfa4 = ratonc*engtab_1.ancfa[indxe8-1] + engtab_1.ancfa[indxe7-1]*ratnc1;
    ancfb1  = engidx_1.ratohb*ancfa2 + ancfa1*engidx_1.rathb1;
    ancfb2  = engidx_1.ratohb*ancfa4 + ancfa3*engidx_1.rathb1;
    ret_val = engidx_1.ratomc*ancfb2 + ancfb1*engidx_1.ratmc1;

    return ret_val;
} /* engsdl_ */

doublereal engsdl_(doublereal *arg)
{
    return engsdl_0_(0, arg);
    }

doublereal c07sdl_(doublereal *arg)
{
    return engsdl_0_(1, arg);
    }

doublereal b07sdl_(doublereal *arg)
{
    return engsdl_0_(2, arg);
    }

#ifdef __cplusplus
//	}
#endif
