C
      REAL FUNCTION B05FCN(B05IN1,B05IN2)
C
C.... FUNCTION TO MODEL AUGMENTOR SEQUENCING LOGIC.
C
C.... WRITTEN AUG. 5, 1978
C     LEE DUKE NASA/DFRC
C
      REAL B05IN1,B05IN2
      INTEGER IC, INDEX, NDX 
      LOGICAL LHOLD
      REAL TIMER,PLAPH,QFT
      REAL T,      P,      Q,      R,    V,    ALP,    BTA,
     .     THA,    PSI,    PHI,    H,    X,    Y,
     .     TDOT,   PDOT,   QDOT,   RDOT, VDOT, ALPDOT, BTADOT,
     .     THADOT, PSIDOT, PHIDOT, HDOT, XDOT, YDOT
      DIMENSION PLAPH(7)
      DIMENSION QFT  (6)
c     INCLUDE 'include.h'
      INCLUDE 'drvout.h'
C
      EQUIVALENCE(T     , F( 1)),
     .           (P     , F( 2)),(Q     , F( 3)),(R     , F( 4)),
     .           (V     , F( 5)),(ALP   , F( 6)),(BTA   , F( 7)),
     .           (THA   , F( 8)),(PSI   , F( 9)),(PHI   , F(10)),
     .           (H     , F(11)),(X     , F(12)),(Y     , F(13)),
     .           (TDOT  ,DF( 1)),
     .           (PDOT  ,DF( 2)),(QDOT  ,DF( 3)),(RDOT  ,DF( 4)),
     .           (VDOT  ,DF( 5)),(ALPDOT,DF( 6)),(BTADOT,DF( 7)),
     .           (THADOT,DF( 8)),(PSIDOT,DF( 9)),(PHIDOT,DF(10)),
     .           (HDOT  ,DF(11)),(XDOT  ,DF(12)),(YDOT  ,DF(13))
C
      DATA NDX	 /7/
      DATA PLAPH /0.0000,0.1713,0.4043,0.5468,0.6804,0.8085,1.0000/
      DATA QFT   /0.43  ,1.0   ,0.37  ,0.37  ,0.67  ,0.46  /
C
      IF(B05IN1.GT.0.0) GO TO 1
      LHOLD =.FALSE.
      IC    =-1
      GO TO 6
    1 CONTINUE
      IF(IC.GT.0) GO TO 4
      IC    =1
      TIMER =0.0
      LHOLD =.FALSE.
      DO 2 INDEX=1,7
      IF(B05IN2.LE.PLAPH(INDEX)) GO TO 3
    2 CONTINUE
      INDEX =7
    3 CONTINUE
      NDX   =INDEX
      GO TO 6
    4 CONTINUE
      IF(NDX.EQ.7) GO TO 6
      IF(PLAPH(NDX).GT.B05IN2) GO TO 6
      IF(LHOLD) GO TO 5
      LHOLD =.TRUE.
      TIMER =T     +QFT(NDX)
    5 CONTINUE
      IF(TIMER.GT.T) GO TO 6
      NDX   =NDX   +1
      LHOLD =.FALSE.
    6 CONTINUE
      B05FCN=0.0
      IF(.NOT.LHOLD) B05FCN=B05IN1
      RETURN
      END
